<template>
    <!-- 白名单配置 -->
    <div class="app-container">
        <TableModel :formLabel="formLabel" :showQueryButtons="false" :showOperation="true" :showRightTools="true" ref="whiteTableRef"
            :columnsList="columnsList" :request-api="getWhiteListAPI">
            <template slot="btn">
                <el-button plain size="mini" type="primary" icon="el-icon-plus" v-hasPermi="['system:whitelist:add']"
                    @click="handleAdd">
                    新增
                </el-button>
            </template>

            <template slot="handle" slot-scope="{ data }">
                <el-button plain size="mini" type="primary" icon="el-icon-edit" v-hasPermi="['system:whitelist:edit']"
                    @click="handleUpdate(data)">
                    修改
                </el-button>
                <el-button plain size="mini" type="danger" icon="el-icon-delete" v-hasPermi="['system:whitelist:remove']"
                    @click="handleDelete(data)">
                    删除
                </el-button>
            </template>
        </TableModel>
        <!-- 新增/编辑 -->
        <WhiteForm v-if="isflag" :isAdd="isAdd" :rowData="row" @handleQuery="handleQuery" :title="title"
            @closeDialog="closeDialog" @showColose="showColose" :dataForm="row" :disabled="loading" :width="600" />
    </div>
</template>

<script>
import TableModel from '@/components/TableModel'
import { columnsList, formLabel } from './config'
import {
    deleteWhiteAPI,
    getWhiteListAPI,
} from '@/api/system/white'
import WhiteForm from './prop/whiteForm'


export default {
    name: 'White',
    components: {
        TableModel,
        WhiteForm
    },
    data() {
        return {
            formLabel,
            columnsList,
            getWhiteListAPI,
            title: "",
            isflag: false,
            isAdd: '',
            row: {},
            loading: false,
        }
    },

    created() {

    },

    methods: {
        /** 新增按钮操作 */
        handleAdd() {
            this.title = "新增";
            this.isAdd = 'add';
            this.isflag = true;
        },
        closeDialog() {
            this.isflag = false;
        },
        showColose() {
            this.isflag = false;
        },
        /** 修改操作 */
        handleUpdate(row) {
            this.title = "修改";
            this.isAdd = 'edit';
            this.row = row;
            this.isflag = true;
        },
        /* 搜索操作 */
        handleQuery() {
            this.$refs.whiteTableRef.getTableList()
        },
        /** 删除操作 */
        handleDelete(row) {
            this.$modal.confirm(`是否确认删除数据？`).then(() => {
                // 显示加载遮罩
                this.$modal.loading("正在删除，请稍候...");
                deleteWhiteAPI({id: row.id}).then(res => {
                    this.$modal.closeLoading();
                    if (res.code === 200) {
                        this.$modal.msgSuccess("删除成功");
                        this.handleQuery();
                    } else {
                        this.$modal.msgError(res.msg);
                    }
                }).catch(error => {
                    this.$modal.closeLoading();
                    this.$modal.msgError(error);
                });
            }).catch(() => {
                // 用户取消删除，不需要处理
            });
        },
    },
}
</script>
